import _asyncToGenerator from "@babel/runtime/helpers/esm/asyncToGenerator";
import _regeneratorRuntime from "@babel/runtime/regenerator";

/* eslint-disable jest/no-conditional-expect */
import React, { useRef } from 'react';
import TestRenderer from 'react-test-renderer';
import { fireEvent, render } from '@testing-library/react';
import '@testing-library/jest-dom';
import userEvent from '@testing-library/user-event';
import TextareaCodeEditor from '../';
it('Should output a TextareaCodeEditor', /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee() {
  var component, tree;
  return _regeneratorRuntime.wrap(function _callee$(_context) {
    while (1) {
      switch (_context.prev = _context.next) {
        case 0:
          component = TestRenderer.create( /*#__PURE__*/React.createElement(TextareaCodeEditor, {
            placeholder: "Please enter JS code."
          }));
          tree = component.toJSON();

          if (tree && !Array.isArray(tree)) {
            expect(tree.type).toEqual('div');
            expect(tree.props.disabled).toBeFalsy();
            expect(tree.props.className).toEqual('w-tc-editor ');
            expect(tree.props.style).toEqual({
              position: 'relative',
              textAlign: 'left',
              boxSizing: 'border-box',
              padding: 0,
              overflow: 'hidden'
            });
            expect(tree.children.length).toEqual(2);
            tree.children.forEach(function (child) {
              if (typeof child === 'object') {
                expect(/^(div|textarea)$/.test(child.type || '')).toBeTruthy();

                if (child.type === 'textarea') {
                  expect(child.props.placeholder).toEqual('Please enter JS code.');
                  expect(child.props.autoComplete).toEqual('off');
                  expect(child.props.autoCorrect).toEqual('off');
                  expect(child.props.spellCheck).toEqual('false');
                  expect(child.props.autoCapitalize).toEqual('off');
                  expect(child.props.className).toEqual('w-tc-editor-text');
                }
              }
            });
          }

        case 3:
        case "end":
          return _context.stop();
      }
    }
  }, _callee);
})));
it('TextareaCodeEditor language="html"', /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee2() {
  var component, tree;
  return _regeneratorRuntime.wrap(function _callee2$(_context2) {
    while (1) {
      switch (_context2.prev = _context2.next) {
        case 0:
          component = TestRenderer.create( /*#__PURE__*/React.createElement(TextareaCodeEditor, {
            language: "html",
            onChange: function onChange() {},
            value: "<div>Hello World!</div>"
          }));
          tree = component.toJSON();

          if (tree && !Array.isArray(tree)) {
            expect(tree.type).toEqual('div');
            expect(tree.props.disabled).toBeFalsy();
            expect(tree.props.className).toEqual('w-tc-editor ');
            expect(tree.props.style).toEqual({
              position: 'relative',
              textAlign: 'left',
              boxSizing: 'border-box',
              padding: 0,
              overflow: 'hidden'
            });
            expect(tree.children.length).toEqual(2);
            tree.children.forEach(function (child) {
              if (typeof child === 'object') {
                expect(/^(div|textarea)$/.test(child.type || '')).toBeTruthy();

                if (child.type === 'textarea') {
                  expect(child.props.autoComplete).toEqual('off');
                  expect(child.props.autoCorrect).toEqual('off');
                  expect(child.props.spellCheck).toEqual('false');
                  expect(child.props.autoCapitalize).toEqual('off');
                  expect(child.props.className).toEqual('w-tc-editor-text');
                }

                if (child.type === 'div') {
                  expect(child.props.style).toEqual({
                    background: 'none',
                    border: 0,
                    boxSizing: 'inherit',
                    display: 'inherit',
                    fontFamily: 'inherit',
                    fontSize: 'inherit',
                    fontStyle: 'inherit',
                    fontVariantLigatures: 'inherit',
                    fontWeight: 'inherit',
                    letterSpacing: 'inherit',
                    lineHeight: 'inherit',
                    margin: 0,
                    minHeight: 16,
                    outline: 0,
                    overflowWrap: 'break-word',
                    paddingTop: 10,
                    paddingRight: 10,
                    paddingBottom: 10,
                    paddingLeft: 10,
                    tabSize: 'inherit',
                    textIndent: 'inherit',
                    textRendering: 'inherit',
                    textTransform: 'inherit',
                    whiteSpace: 'pre-wrap',
                    wordBreak: 'keep-all'
                  });
                  expect(child.props.className).toEqual('w-tc-editor-preview language-html');
                  expect(typeof child.props.dangerouslySetInnerHTML).toEqual('object');
                }
              }
            });
          }

        case 3:
        case "end":
          return _context2.stop();
      }
    }
  }, _callee2);
})));
it('TextareaCodeEditor onChange', /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee3() {
  var MyComponent, _render, firstChild;

  return _regeneratorRuntime.wrap(function _callee3$(_context3) {
    while (1) {
      switch (_context3.prev = _context3.next) {
        case 0:
          MyComponent = function MyComponent() {
            var txtRef = useRef(null);

            var _React$useState = React.useState("function add(a, b) {\n  return a + b;\n}"),
                code = _React$useState[0];

            return /*#__PURE__*/React.createElement(TextareaCodeEditor, {
              language: "js",
              value: code,
              ref: txtRef,
              onChange: function onChange(evn) {
                expect(evn.target.value).toEqual('a');
              }
            });
          };

          _render = render( /*#__PURE__*/React.createElement(MyComponent, null)), firstChild = _render.container.firstChild;

          if (firstChild && firstChild.firstChild) {
            fireEvent.input(firstChild.firstChild, {
              target: {
                value: 'a'
              }
            });
          }

        case 3:
        case "end":
          return _context3.stop();
      }
    }
  }, _callee3);
})));
it('TextareaCodeEditor Tab Input', /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee4() {
  var _render2, firstChild;

  return _regeneratorRuntime.wrap(function _callee4$(_context4) {
    while (1) {
      switch (_context4.prev = _context4.next) {
        case 0:
          _render2 = render( /*#__PURE__*/React.createElement(TextareaCodeEditor, {
            language: "js",
            "data-testid": "textarea",
            autoFocus: true,
            value: "console.log('This is a bad example')"
          })), firstChild = _render2.container.firstChild;

          if (firstChild && firstChild.firstChild) {
            firstChild.firstChild.setSelectionRange(23, 26);
            userEvent.type(firstChild.firstChild, '{backspace}good');
            expect(firstChild.firstChild).toHaveFocus();
            expect(firstChild.firstChild).toHaveValue("console.log('This is a good example')");
            fireEvent.keyDown(firstChild.firstChild, {
              key: 'Tab',
              code: 'Tab',
              charCode: 9
            });
          }

        case 2:
        case "end":
          return _context4.stop();
      }
    }
  }, _callee4);
})));
it('TextareaCodeEditor onKeyDown Tab Input', /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee5() {
  var _render3, firstChild;

  return _regeneratorRuntime.wrap(function _callee5$(_context5) {
    while (1) {
      switch (_context5.prev = _context5.next) {
        case 0:
          _render3 = render( /*#__PURE__*/React.createElement(TextareaCodeEditor, {
            language: "js",
            "data-testid": "textarea",
            autoFocus: true,
            value: "console.log('This is a bad example')",
            onKeyDown: function onKeyDown(evn) {
              expect(evn.code.toLowerCase()).toEqual('tab');
              expect(evn.target.value).toEqual("console.log('This is a    example')");
            }
          })), firstChild = _render3.container.firstChild;

          if (firstChild && firstChild.firstChild) {
            firstChild.firstChild.setSelectionRange(23, 26);
            fireEvent.keyDown(firstChild.firstChild, {
              key: 'Tab',
              code: 'Tab',
              charCode: 9
            });
          }

        case 2:
        case "end":
          return _context5.stop();
      }
    }
  }, _callee5);
})));
it('TextareaCodeEditor onKeyDown Tab One-Line Input', /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee6() {
  var _render4, firstChild;

  return _regeneratorRuntime.wrap(function _callee6$(_context6) {
    while (1) {
      switch (_context6.prev = _context6.next) {
        case 0:
          _render4 = render( /*#__PURE__*/React.createElement(TextareaCodeEditor, {
            language: "js",
            "data-testid": "textarea",
            autoFocus: true,
            value: "console.log('This is a bad example')\nconsole.log('This is a good example')",
            onKeyDown: function onKeyDown(evn) {
              expect(evn.code.toLowerCase()).toEqual('tab');
              expect(evn.target.value).toEqual("  console.log('This is a bad example')\n  console.log('This is a good example')");
            }
          })), firstChild = _render4.container.firstChild;

          if (firstChild && firstChild.firstChild) {
            firstChild.firstChild.setSelectionRange(4, 60);
            fireEvent.keyDown(firstChild.firstChild, {
              key: 'Tab',
              code: 'Tab',
              charCode: 9
            });
          }

        case 2:
        case "end":
          return _context6.stop();
      }
    }
  }, _callee6);
})));
it('TextareaCodeEditor onKeyDown Tab Multi-Line Input', /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee7() {
  var example, expected, _render5, firstChild;

  return _regeneratorRuntime.wrap(function _callee7$(_context7) {
    while (1) {
      switch (_context7.prev = _context7.next) {
        case 0:
          example = "\nfunction stopPropagation(e) {\n  e.stopPropagation();\n  e.preventDefault();\n}";
          expected = "\nfunction stopPropagation(e) {\ne.stopPropagation();\ne.preventDefault();\n}";
          _render5 = render( /*#__PURE__*/React.createElement(TextareaCodeEditor, {
            language: "js",
            "data-testid": "textarea",
            autoFocus: true,
            value: example,
            onKeyDown: function onKeyDown(evn) {
              expect(evn.code.toLowerCase()).toEqual('tab');
              expect(evn.target.value).toEqual(expected);
            }
          })), firstChild = _render5.container.firstChild;

          if (firstChild && firstChild.firstChild) {
            firstChild.firstChild.setSelectionRange(38, 67);
            fireEvent.keyDown(firstChild.firstChild, {
              key: 'Tab',
              code: 'Tab',
              charCode: 9,
              shiftKey: true
            });
          }

        case 4:
        case "end":
          return _context7.stop();
      }
    }
  }, _callee7);
})));
it('TextareaCodeEditor onKeyDown Tab Multi-Line 2 Input', /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee8() {
  var example, expected, _render6, firstChild;

  return _regeneratorRuntime.wrap(function _callee8$(_context8) {
    while (1) {
      switch (_context8.prev = _context8.next) {
        case 0:
          example = "\nfunction stopPropagation(e) {\n  e.stopPropagation();\n  e.preventDefault();\n}";
          expected = "\nfunction stopPropagation(e) {\ne.stopPropagation();\ne.preventDefault();\n}";
          _render6 = render( /*#__PURE__*/React.createElement(TextareaCodeEditor, {
            language: "js",
            "data-testid": "textarea",
            autoFocus: true,
            value: example,
            onKeyDown: function onKeyDown(evn) {
              expect(evn.code.toLowerCase()).toEqual('tab');
              expect(evn.target.value).toEqual(expected);
            }
          })), firstChild = _render6.container.firstChild;

          if (firstChild && firstChild.firstChild) {
            firstChild.firstChild.setSelectionRange(6, 67);
            fireEvent.keyDown(firstChild.firstChild, {
              key: 'Tab',
              code: 'Tab',
              charCode: 9,
              shiftKey: true
            });
          }

        case 4:
        case "end":
          return _context8.stop();
      }
    }
  }, _callee8);
})));
it('TextareaCodeEditor onKeyDown Enter Input', /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee9() {
  var example, expected, _render7, firstChild;

  return _regeneratorRuntime.wrap(function _callee9$(_context9) {
    while (1) {
      switch (_context9.prev = _context9.next) {
        case 0:
          example = "\nfunction stopPropagation(e) {\n  e.stopPropagation();\n  e.preventDefault();\n}";
          expected = "\nfunction stopPropagation(e) {\n \n  e.stopPropagation();\n  e.preventDefault();\n}";
          _render7 = render( /*#__PURE__*/React.createElement(TextareaCodeEditor, {
            language: "js",
            "data-testid": "textarea",
            autoFocus: true,
            value: example,
            onKeyDown: function onKeyDown(evn) {
              expect(evn.code.toLowerCase()).toEqual('enter');
              expect(evn.target.value).toEqual(expected);
            }
          })), firstChild = _render7.container.firstChild;

          if (firstChild && firstChild.firstChild) {
            firstChild.firstChild.setSelectionRange(32, 32);
            fireEvent.keyDown(firstChild.firstChild, {
              key: 'Enter',
              code: 'Enter',
              charCode: 13
            });
          }

        case 4:
        case "end":
          return _context9.stop();
      }
    }
  }, _callee9);
})));
it('TextareaCodeEditor onKeyDown Input `()`', /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee10() {
  var example, expected, _render8, firstChild;

  return _regeneratorRuntime.wrap(function _callee10$(_context10) {
    while (1) {
      switch (_context10.prev = _context10.next) {
        case 0:
          example = "/** Hello Wold **/";
          expected = "/** (Hello) Wold **/";
          _render8 = render( /*#__PURE__*/React.createElement(TextareaCodeEditor, {
            language: "js",
            "data-testid": "textarea",
            autoFocus: true,
            value: example,
            onKeyDown: function onKeyDown(evn) {
              expect(evn.code.toLowerCase()).toEqual('digit9');
              expect(evn.target.value).toEqual(expected);
            }
          })), firstChild = _render8.container.firstChild;

          if (firstChild && firstChild.firstChild) {
            firstChild.firstChild.setSelectionRange(4, 9);
            fireEvent.keyDown(firstChild.firstChild, {
              key: '(',
              code: 'Digit9',
              charCode: 57,
              shiftKey: true
            });
          }

        case 4:
        case "end":
          return _context10.stop();
      }
    }
  }, _callee10);
})));
it('TextareaCodeEditor onKeyDown Input `<>`', /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee11() {
  var example, expected, _render9, firstChild;

  return _regeneratorRuntime.wrap(function _callee11$(_context11) {
    while (1) {
      switch (_context11.prev = _context11.next) {
        case 0:
          example = "/** Hello Wold **/";
          expected = "/** <Hello> Wold **/";
          _render9 = render( /*#__PURE__*/React.createElement(TextareaCodeEditor, {
            language: "js",
            "data-testid": "textarea",
            autoFocus: true,
            value: example,
            onKeyDown: function onKeyDown(evn) {
              expect(evn.code.toLowerCase()).toEqual('comma');
              expect(evn.target.value).toEqual(expected);
            }
          })), firstChild = _render9.container.firstChild;

          if (firstChild && firstChild.firstChild) {
            firstChild.firstChild.setSelectionRange(4, 9);
            fireEvent.keyDown(firstChild.firstChild, {
              key: '<',
              code: 'Comma',
              charCode: 188,
              shiftKey: true
            });
          }

        case 4:
        case "end":
          return _context11.stop();
      }
    }
  }, _callee11);
})));
it('TextareaCodeEditor onKeyDown Input `[]`', /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee12() {
  var example, expected, _render10, firstChild;

  return _regeneratorRuntime.wrap(function _callee12$(_context12) {
    while (1) {
      switch (_context12.prev = _context12.next) {
        case 0:
          example = "/** Hello Wold **/";
          expected = "/** [Hello] Wold **/";
          _render10 = render( /*#__PURE__*/React.createElement(TextareaCodeEditor, {
            language: "js",
            "data-testid": "textarea",
            autoFocus: true,
            value: example,
            onKeyDown: function onKeyDown(evn) {
              expect(evn.code.toLowerCase()).toEqual('bracketleft');
              expect(evn.target.value).toEqual(expected);
            }
          })), firstChild = _render10.container.firstChild;

          if (firstChild && firstChild.firstChild) {
            firstChild.firstChild.setSelectionRange(4, 9);
            fireEvent.keyDown(firstChild.firstChild, {
              key: '[',
              code: 'BracketLeft',
              charCode: 219
            });
          }

        case 4:
        case "end":
          return _context12.stop();
      }
    }
  }, _callee12);
})));
it('TextareaCodeEditor onKeyDown Input `{}`', /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee13() {
  var example, expected, _render11, firstChild;

  return _regeneratorRuntime.wrap(function _callee13$(_context13) {
    while (1) {
      switch (_context13.prev = _context13.next) {
        case 0:
          example = "/** Hello Wold **/";
          expected = "/** {Hello} Wold **/";
          _render11 = render( /*#__PURE__*/React.createElement(TextareaCodeEditor, {
            language: "js",
            "data-testid": "textarea",
            autoFocus: true,
            value: example,
            onKeyDown: function onKeyDown(evn) {
              expect(evn.code.toLowerCase()).toEqual('bracketleft');
              expect(evn.target.value).toEqual(expected);
            }
          })), firstChild = _render11.container.firstChild;

          if (firstChild && firstChild.firstChild) {
            firstChild.firstChild.setSelectionRange(4, 9);
            fireEvent.keyDown(firstChild.firstChild, {
              key: '{',
              code: 'BracketLeft',
              charCode: 219,
              shiftKey: true
            });
          }

        case 4:
        case "end":
          return _context13.stop();
      }
    }
  }, _callee13);
})));
it("TextareaCodeEditor onKeyDown Input `''`", /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee14() {
  var example, expected, _render12, firstChild;

  return _regeneratorRuntime.wrap(function _callee14$(_context14) {
    while (1) {
      switch (_context14.prev = _context14.next) {
        case 0:
          example = "/** Hello Wold **/";
          expected = "/** 'Hello' Wold **/";
          _render12 = render( /*#__PURE__*/React.createElement(TextareaCodeEditor, {
            language: "js",
            "data-testid": "textarea",
            autoFocus: true,
            value: example,
            onKeyDown: function onKeyDown(evn) {
              expect(evn.code.toLowerCase()).toEqual('quote');
              expect(evn.target.value).toEqual(expected);
            }
          })), firstChild = _render12.container.firstChild;

          if (firstChild && firstChild.firstChild) {
            firstChild.firstChild.setSelectionRange(4, 9);
            fireEvent.keyDown(firstChild.firstChild, {
              key: "'",
              code: 'Quote',
              charCode: 222
            });
          }

        case 4:
        case "end":
          return _context14.stop();
      }
    }
  }, _callee14);
})));
it('TextareaCodeEditor onKeyDown Input `""`', /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee15() {
  var example, expected, _render13, firstChild;

  return _regeneratorRuntime.wrap(function _callee15$(_context15) {
    while (1) {
      switch (_context15.prev = _context15.next) {
        case 0:
          example = "/** Hello Wold **/";
          expected = "/** \"Hello\" Wold **/";
          _render13 = render( /*#__PURE__*/React.createElement(TextareaCodeEditor, {
            language: "js",
            "data-testid": "textarea",
            autoFocus: true,
            value: example,
            onKeyDown: function onKeyDown(evn) {
              expect(evn.code.toLowerCase()).toEqual('quote');
              expect(evn.target.value).toEqual(expected);
            }
          })), firstChild = _render13.container.firstChild;

          if (firstChild && firstChild.firstChild) {
            firstChild.firstChild.setSelectionRange(4, 9);
            fireEvent.keyDown(firstChild.firstChild, {
              key: '"',
              code: 'Quote',
              charCode: 222,
              shiftKey: true
            });
          }

        case 4:
        case "end":
          return _context15.stop();
      }
    }
  }, _callee15);
})));
it('TextareaCodeEditor onKeyDown Input ``', /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee16() {
  var example, expected, _render14, firstChild;

  return _regeneratorRuntime.wrap(function _callee16$(_context16) {
    while (1) {
      switch (_context16.prev = _context16.next) {
        case 0:
          example = "/** Hello Wold **/";
          expected = "/** `Hello` Wold **/";
          _render14 = render( /*#__PURE__*/React.createElement(TextareaCodeEditor, {
            language: "js",
            "data-testid": "textarea",
            autoFocus: true,
            value: example,
            onKeyDown: function onKeyDown(evn) {
              expect(evn.code.toLowerCase()).toEqual('backquote');
              expect(evn.target.value).toEqual(expected);
            }
          })), firstChild = _render14.container.firstChild;

          if (firstChild && firstChild.firstChild) {
            firstChild.firstChild.setSelectionRange(4, 9);
            fireEvent.keyDown(firstChild.firstChild, {
              key: '`',
              code: 'Backquote',
              charCode: 192
            });
          }

        case 4:
        case "end":
          return _context16.stop();
      }
    }
  }, _callee16);
})));
//# sourceMappingURL=index.test.js.map